import { List, fromJS } from 'immutable'
import React from 'react'

import Sidebar from './Sidebar'
import Workspace from './Workspace'

import { onSetState } from '../shared/io'
import { fromServer } from '../model'

const convertTypes = state => fromJS(state)
  .update('modifiers', List)
  .update(state =>
    state.has('component')
      ? state.set('hierarchy', fromServer(state.get('component')))
      : state
  )

export default React.createClass({
  contextTypes: {
    history: React.PropTypes.object
  },
  getInitialState () {
    return {}
  },
  componentDidMount () {
    onSetState(state => {
      // console.log('setState', '-------')
      this.setState({
        server: convertTypes(state)
      }, () => {
        // console.log(this.state.server.toJS())
      })
    })
  },
  render () {
    const { server } = this.state
    if (!server) return null
    return (
      <div className='slds-grid slds-grid--vertical slds-grid--frame app'>
        <div className='slds-grid' style={{ flex: 1 }}>
          <Sidebar
            server={server}
            style={{
              width: 380
            }} />
          <Workspace
            server={server}
            style={{
              flex: 1,
              padding: '0.25rem'
            }} />
        </div>
        <style jsx global>{`
          html, body, .slds-grid--frame {
            margin: 0;
            padding: 0;
          }
          .app {
            background: #FAFCFF;
          }
          .slds-text-longform h4 {
            font-weight: 700;
            margin-bottom: 0.75rem;
          }
          .restriction-tree__item:hover .selector-type-badge {
            box-shadow: currentColor 0 0 0 1px inset;
          }
          .restriction-tree__item:hover .modifier-group-badge {
            opacity: 1;
          }
          ::-webkit-scrollbar {
            width: 6px;
            height: 6px;
          }
          ::-webkit-scrollbar-track {
            background: #F4F6F9;
            border-radius: 8px;
          }
          ::-webkit-scrollbar-thumb {
            border-radius: 8px;
            background: #D8DDE6;
            box-shadow: #F4F6F9 0 0 0 1px inset;
          }
          ::-webkit-scrollbar-thumb:window-inactive {
            background: #F4F6F9;
          }
        `}</style>
      </div>
    )
  }
})
