import escape from 'escape-html'
import escapeRegExp from 'lodash/escapeRegExp'
import React from 'react'

export default props =>
  <div className='host'>
    {!props.errors.count()
      ? null : <pre style={{ maxHeight: 200, overflow: 'auto' }}>
        <code
          dangerouslySetInnerHTML={{
            __html: props.markup.split('\n').map(line => {
              let invalid = props.errors.reduce((match, item) => {
                return match !== null
                    ? match
                    : line.match(new RegExp(escapeRegExp(item.get('element'))))
              }, null)
              let style = invalid
                  ? 'color: red;'
                  : ''
              return `<span style="${style}">${escape(line)}</span>`
            }).join('\n')
          }} />
      </pre>}
    <style jsx>{`
      .host {
        display: flex;
        padding: 0.5rem;
      }
      pre {
        flex: 1;
        width: 0;
        margin: 0;
        overflow: auto;
        max-height: 200px;
      }
    `}</style>
  </div>
