import React from 'react'
import Immutable from 'immutable'

import MarkupErrors from './MarkupErrors'
import Preview from './Preview'

export default React.createClass({
  getDefaultProps () {
    return {
      markup: '',
      styles: Date.now(),
      width: '100%'
    }
  },
  getInitialState () {
    return {
      showErrors: false
    }
  },
  render () {
    const { props } = this
    return (
      <div className='host'>
        <div className='preview'>
          <Preview
            modifiers={props.server.get('modifiers')}
            markup={props.preview.get('markup')}
            styles={props.styles} />
        </div>
        <footer>
          <span>{props.preview.get('id', 'base')} ({props.type})</span>
          <button className='slds-button slds-line-height--reset' onClick={() => {
            this.setState({
              showErrors: !this.state.showErrors
            })
          }}>
            <svg
              aria-hidden='true'
              className='slds-button__icon slds-button__icon--small slds-button__icon--left slds-icon-text-error'>
              <use xlinkHref='/assets/icons/utility-sprite/svg/symbols.svg#error' />
            </svg>
            {props.preview.get('errors', Immutable.List()).count()}
            <span className='slds-assistive-text'>Errors</span>
          </button>
        </footer>
        {!this.state.showErrors ? null : <MarkupErrors
          markup={props.preview.get('markup')}
          errors={props.preview.get('errors')} />
        }
        <style jsx>{`
          .host {
            background: #fff;
            margin: 0 0 2rem 0;
            box-shadow: 0 1px 3px 0 rgba(0, 0, 0, 0.15);
          }
          .preview {
            padding: 0.5rem;
          }
          footer {
            display: flex;
            justify-content: space-between;
            align-items: center;
            padding: 0.5rem;
          }
          footer span {
            margin: 0 0.25rem;
          }
        `}</style>
      </div>
    )
  }
})
