import { List } from 'immutable'
import React from 'react'

import PreviewPane from './PreviewPane'

export default ({ server, style }) =>
  <div
    className='slds-grid slds-grid--vertical'
    style={style}>
    <div style={{
      flex: '1 1 auto',
      height: 0,
      overflowY: 'auto',
      padding: '1rem'
    }}>
      {server.get('markup', List()).map(section => {
        const type = section.get('title')
        return List.of(
          <div key={section.get('title')}>
            <h1>{type}</h1>
            {section.get('items').map((preview, index) =>
              <PreviewPane
                key={`${type}-${index}`}
                type={type}
                server={server}
                preview={preview}
                styles={server.get('styles')} />
            )}
          </div>
        )
      }).toList().flatten().toArray()}
    </div>
  </div>
