const getContentOrigin = () => {
  let { protocol, host } = window.location
  return `${protocol}//${host}`
}

const dispatch = (type, payload) => {
  window.parent.postMessage({ type, payload }, getContentOrigin())
}

const handlers = {
  styles: payload => {
    const link = document.querySelector('link')
    link.href = link.href.replace(/(.+?)(\?.+)?$/, (match, url) => {
      return `${url}?cache=${payload.styles}`
    })
  },
  markup: payload => {
    const preview = document.getElementById('preview')
    preview.setAttribute('style', 'padding: 0.5rem')
    preview.innerHTML = payload.markup
    dispatch('iframe:height', {
      id: payload.id,
      height: preview.clientHeight
    })
    dispatch('iframe:applyModifiers', {
      id: payload.id
    })
  }
}

window.addEventListener('message', (e) => {
  const { type, payload } = e.data
  const handler = handlers[type]
  if (typeof handler === 'function') {
    handler(payload)
  }
})
