import {fromNullable} from 'data.either'

const getType = x =>
  x.getIn(['annotations', 'base'])
  ? 'component'
  : x.getIn(['annotations', 'variant'])
    ? 'variant'
    : x.getIn(['annotations', 'modifier'])
      ? 'modifier'
      : 'element'

export const toComment = x => x
  .merge(x.get('annotations'))
  .set('type', getType(x))

export const mapTree = (x, f) =>
  f(x).set('restrictees', x.get('restrictees').map(r => mapTree(r, f)))

export const cata = (comment, f) =>
  fromNullable(comment.get('type'))
  .chain(t =>
    fromNullable(f[t]))
    .map(fn => fn(comment))
  .getOrElse(null)

export const fromServer = x =>
  mapTree(x, toComment)
