const path = require('path')
const local = path.resolve.bind(path, __dirname)

module.exports = {
  context: __dirname,
  entry: {
    previewer: local('client/previewer.jsx'),
    iframe: local('client/iframe.js')
  },
  output: {
    path: local('.dist'),
    filename: '[name].js',
    publicPath: '/__ASSETS__/scripts/bundle/'
  },
  module: {
    rules: [{
      test: /\.jsx?$/,
      exclude: /node_modules/,
      loader: 'babel-loader',
      options: {
        babelrc: false,
        presets: [
          require('babel-preset-es2015'),
          require('babel-preset-react')
        ],
        plugins: [
          require('styled-jsx/babel').default
        ]
      }
    }]
  },
  resolve: {
    extensions: ['.js', '.jsx']
  }
}
